import socket
import time
import random
import json

def main():
    localhost = '127.0.0.1'
    port = 5008

    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.bind((localhost, port))

    width = 800
    height = 600
    N = width * height
    metadata = {"color": "RGB", "width": width, "height": height}
    metadataToSend = json.dumps(metadata)
    pixel_grey = [155, 155, 155]
    pixel_red = [255, 0, 0]

    row = [pixel_grey] * width

    while True:
        data, addr = sock.recvfrom(1024)
        while True:
            time.sleep(1)
            sock.sendto('start::'.encode('utf-8'), addr)
            for i in range(height):
                new_row = row.copy()
                index = random.randint(0, width - 1)
                new_row[index] = pixel_red
                sock.sendto(str(new_row).encode('utf-8'), addr)
            sock.sendto(metadataToSend.encode('utf-8'), addr)
            sock.sendto('end::'.encode('utf-8'), addr)


if __name__ == '__main__':
    main()